function fig = crspline(action,param)
% Creat base spline
% Detailed look in an information.
%
% Shelev@yahoo.com

%       I.V.Shelevitsky 03-07-02
%       Revised  03/07/02
%       Copyright (c) 2002 by the Shelevitsky
%
   
if nargin==0,
   action = 'initialize';
end
if nargin==1,
   param = 'initialize';
end

switch action, 
case 'initialize',
   % Initialize Graphics

h0 = figure('Units','points', ...
        'NumberTitle','off',...
	'Color',[0.8 0.8 0.8], ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[12 30.75 420 281.25], ...
	'Tag','Fig1', ...
        'Name','Creat base spline', ...  
	'ToolBar','none');

popstr1={'Alg.polinom' 'Exponent' 'Power' 'Sinus' 'Gausian'}; % 'User define'};
p1=[1 1 1; 5 0 0; 0.5 0 1; pi/2 0 1; 1 0 0; 1 1 1]; 
pm1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.823 0.88 0.157 0.06], ...
	'String',popstr1, ...
	'Style','popupmenu', ...
	'Tag','PopupMenu1', ...
        'UserData',{popstr1,p1,1},...
        'CallBack','crspline(''func1''); crspline(''recal'')',... 
	'Value',1);
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.93 0.75 0.75], ...
	'ListboxTop',0, ...
	'Position',[0.823 0.94 0.155 0.053], ...
	'String','function 1', ...
	'Style','text', ...
	'Tag','StaticText1');

p2=[0 0 1; 5 0 0; 0.5 0 1; pi/2 0 1; 1 0 0; 1 1 1]; 
pm2 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.823 0.76 0.157 0.06], ...
	'String',popstr1, ...
	'Style','popupmenu', ...
	'Tag','PopupMenu2', ...
        'UserData',{popstr1 p2 1},...
        'CallBack','crspline(''func2''); crspline(''recal'')',... 
	'Value',1);

      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'ListboxTop',0, ...
	'Position',[0.823 0.82 0.155 0.053], ...
	'String','function 2', ...
	'Style','text', ...
	'Tag','StaticText1');

    a_f1 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.60 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',1,...
        'String',' 1',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.60 0.05 0.05], ...
	'String',' a ', ...
	'Style','text');
    b_f1 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.54 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',1,...
        'String',' 1',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.54 0.05 0.05], ...
	'String',' b ', ...
	'Style','text');
    c_f1 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.48 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',1,...
        'String',' 1',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.48 0.05 0.05], ...
	'String',' c ', ...
	'Style','text');

    a_f2 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.30 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',0,...
        'String',' 0',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.30 0.05 0.05], ...
	'String',' a ', ...
	'Style','text');
    b_f2 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.24 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',0,...
        'String',' 0',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.24 0.05 0.05], ...
	'String',' b ', ...
	'Style','text');
    c_f2 = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position', [0.83 0.18 0.08 0.05], ...
        'BackgroundColor','w',...
        'Value',1,...
        'String',' 1',...
        'CallBack','crspline(''param''); crspline(''recal'')');
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.92 0.18 0.05 0.05], ...
	'String',' c ', ...
	'Style','text');

%==============================================================
   % Info and Close buttons
   tposition6 = [.83 .12 .15 .05];
   uicontrol(...
      'String','Save spline',...
      'Units','normalized',...
      'Position',tposition6,...
      'Callback','crspline(''savespl'')');
   tposition7 = [.83 .065 .15 .05];
   uicontrol(...
      'String','Info',...
      'Units','normalized',...
      'Position',tposition7,...
      'Callback','crspline(''info'')');
   tposition8 = [.83 .01 .15 .05];
   uicontrol(...
      'String','Close',...
      'Units','normalized',...
      'ForegroundColor','black',...
      'Position',tposition8,...
      'Callback','crspline(''done'')');
%==============================================================
        tf=0:0.01:1.99;
        tb=0:0.01:3.99;
        [f1,f2,b,bh,w,h1,h2,hb,hh]=update_signal('Alg.polinom','Alg.polinom',1,1,1,0,1,1);
% Graphics
ax1 = axes('Parent',h0, ...
	'Color',[1 1 1], ...
        'FontSize',[8], ...
	'Position',[0.04 0.55 0.36 0.37], ...
	'Tag','Axes1'); plot(tf,f1,tf,f2);
        a=axis; a(1)=0; a(2)=2; axis(a);
        set(ax1,'YLimMode','auto');
ftxt1=title('ax^{3}+bx^{2}+cx');
        set(ftxt1,'Units','normalized');
        set(ftxt1,'FontSize',[10]);
	set(ftxt1,'Position',[2.35 0.43]);
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.04 0.94 0.36 0.053], ...
	'String','Source functions', ...
	'Style','text', ...
	'Tag','StTextA1');

ax2 = axes('Parent',h0, ...
	'Color',[1 1 1], ...
	'XLimMode','manual', ...
	'XLim',[0 0.5], ...
        'FontSize',[8], ...
	'Position',[0.45 0.55 0.36 0.37], ...
	'Tag','Axes2'); plot(w,h1,w,h2,w(1:80)*10,h1(1:80),w(1:80)*10,h2(1:80));
        axis([0 0.5 -100 10]);
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.45 0.94 0.36 0.053], ...
	'String','Spectr functions', ...
	'Style','text', ...
	'Tag','StTextA2');

ax3 = axes('Parent',h0, ...
	'Color',[1 1 1], ...
	'XLimMode','manual', ...
	'XLim',[0 4], ...
        'FontSize',[8], ...
	'Position',[0.04 0.05 0.36 0.37], ...
	'Tag','Axes3');   plot(tb,b,tb,bh);
        axis([0 4 min([b bh]) max([b bh])]);
        set(ax3,'YLimMode','auto');
ftxt2=title('ax^{3}+bx^{2}+cx');
        set(ftxt2,'Units','normalized');
        set(ftxt2,'FontSize',[10]);
	set(ftxt2,'Position',[2.35 1]);
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.04 0.43 0.36 0.053], ...
	'String','Spline bases', ...
	'Style','text', ...
	'Tag','StTextA3');

ax4 = axes('Parent',h0, ...
	'Color',[1 1 1], ...
	'XLimMode','manual', ...
	'XLim',[0 0.5], ...
        'FontSize',[8], ...
	'Position',[0.45 0.05 0.36 0.37], ...
	'Tag','Axes4'); plot(w,hb,w,hb,w(1:80)*10,hb(1:80),w(1:80)*10,hh(1:80));
        axis([0 0.5 -100 10]);
      uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.45 0.43 0.36 0.053], ...
	'String','Spectr splines', ...
	'Style','text', ...
	'Tag','StTextA4');


      fn1='Alg.polinom';
      fn2='Alg.polinom';
      a1 = 1;
      b1 = 1;
      c1 = 1;
      a2 = 0;
      b2 = 0;
      c2 = 1;

      hndlList=[ax1 ax2 ax3 ax4 pm1 pm2 a_f1 b_f1 c_f1 a_f2 b_f2 c_f2 ftxt1 ftxt2];
      set(h0,'UserData',hndlList);

      update_gui(fn1,fn2,a1,b1,c1,a2,b2,c2);

case 'func1'
   hL=get(gcf,'Userdata');
   a1=get(hL(7),'Value');
   b1=get(hL(8),'Value');
   c1=get(hL(9),'Value');
   ud=get(hL(5),'Userdata');
   ndx=ud{3};  ud{2}(ndx,1)=a1;
   ud{2}(ndx,2)=b1; ud{2}(ndx,3)=c1;
   ndx=get(hL(5),'Value');  ud{3}=ndx;
   set(hL(5),'Userdata',ud);
   a1=ud{2}(ndx,1); b1=ud{2}(ndx,2); c1=ud{2}(ndx,3); 
   set(hL(7),'Value',a1);
   set(hL(8),'Value',b1);
   set(hL(9),'Value',c1);
   set(hL(7),'String',num2str(a1));
   set(hL(8),'String',num2str(b1));
   set(hL(9),'String',num2str(c1));
   formul={'a*x^{3}+b*x^{2}+c*x' 'e^{-a*(1-x)}' '(b+c*x)^{a}' ...
           '{c}*sin(a*x+b)' 'e^{-(x-1)^{2}/{(2a^{2})}}' };
   set(hL(13),'String',formul{ndx});
case 'func2'
   hL=get(gcf,'Userdata');
   a2=get(hL(10),'Value');
   b2=get(hL(11),'Value');
   c2=get(hL(12),'Value');
   ud=get(hL(6),'Userdata');
   ndx=ud{3};  ud{2}(ndx,1)=a2;
   ud{2}(ndx,2)=b2; ud{2}(ndx,3)=c2;
   ndx=get(hL(6),'Value');  ud{3}=ndx;
   set(hL(6),'Userdata',ud);
   a2=ud{2}(ndx,1); b2=ud{2}(ndx,2); c2=ud{2}(ndx,3); 
   set(hL(10),'Value',a2);
   set(hL(11),'Value',b2);
   set(hL(12),'Value',c2);
   set(hL(10),'String',num2str(a2));
   set(hL(11),'String',num2str(b2));
   set(hL(12),'String',num2str(c2));
   formul={'a*x^{3}+b*x^{2}+c*x' 'e^{-a*(1-x)}' '(b+c*x)^{a}' ...
           '{c}*sin(a*x+b)' 'e^{-(x-1)^{2}/{(2a^{2})}}' };
   set(hL(14),'String',formul{ndx});
case 'param'
   hL=get(gcf,'Userdata');
   for i=7:9
      s1=get(hL(i),'String');
      set(hL(i),'Value',str2num(s1));
      s1=get(hL(i+3),'String');
      set(hL(i+3),'Value',str2num(s1));
   end
case 'recal'
   fL=get(gcf,'Userdata');
      ndx= get(fL( 5),'Value');
      prm= get(fL( 5),'UserData');
      prm=prm{1}; 
      fn1=prm(ndx);
      ndx= get(fL( 6),'Value');
      prm= get(fL( 6),'UserData');
      prm=prm{1};
      fn2=prm(ndx);
      a1 = get(fL( 7),'Value');
      b1 = get(fL( 8),'Value');
      c1 = get(fL( 9),'Value');
      a2 = get(fL(10),'Value');
      b2 = get(fL(11),'Value');
      c2 = get(fL(12),'Value');
      update_gui(fn1,fn2,a1,b1,c1,a2,b2,c2);
case 'savespl'
      save_spline(param); 
case 'info',
   hlpEng=['Not found'];
   hlpUkr=['Not found'];
   hlpRus=['Not found'];
   hlpStr=['']; 
   [df,mess]=fopen('crspline.txt','r');
   if df>0
      while 1
         line = fgetl(df);
         if ~isstr(line), break, end
         if strcmp(line,'$engl$')>0
            hlpEng=hlpStr;
            hlpStr=[' '];
            line='';
         end
         if strcmp(line,'$ukr$')>0
            hlpUkr=hlpStr;
            hlpStr=[' '];
            line='';
         end
         if strcmp(line,'$rus$')>0
            hlpRus=hlpStr;
            hlpStr=[' '];
            line='';
         end
         hlpStr=[hlpStr char(10) line];
      end
      fclose(df);
      hlpEng=withtxt(hlpEng,70);
      hlpUkr=withtxt(hlpUkr,70);
      hlpRus=withtxt(hlpRus,70);
      helpwin({'English. Others look in topics' hlpEng; ...
               'Ukraine. Others look in topics' hlpUkr; ...
               'Rusian.  Others look in topics' hlpRus },'Language');
   else
     helpwin(mess, 'crspline');
   end
   return
case 'done',
   close(gcf);
end        

function [f1,f2,b,bh,w,h1,h2,hb,hh]=update_signal(fn1,fn2,a1,b1,c1,a2,b2,c2,n)
%
%
%'Alg.polinom' 'Exponent' 'Rational' 'Sinus' 'Gausian' 'User define'
if nargin<9
   n=100;
end
dn=1/n;
x=0:dn:1;
if iscell(fn1)
   fn1=fn1{1};
end

switch deblank(fn1), 
case 'Alg.polinom',
  f1=a1*(x.^3)+b1*(x.^2)+c1*x; 
case 'Exponent'
  f1=exp(-a2*(1-x));
case 'Sinus'
  f1=c1*sin(a1*x+b1);
case 'Power'
  f1=(b2+c2*x).^a2; 
case 'Gausian'
  f1=(1/(2*pi*a1))*exp(-((x-1).*(x-1))/(2*a1*a1));
otherwise
  f1=a1*(x.^3)+b1*(x.^2)+c1*x; 
end

if iscell(fn2)
   fn2=fn2{1};
end
switch deblank(fn2), 
case 'Alg.polinom',
  f2=a2*(x.^3)+b2*(x.^2)+c2*x; 
case 'Exponent'
  f2=exp(-a2*(1-x));
case 'Sinus'
  f2=c2*sin(a2*x+b2);
case 'Power'
  f2=(b2+c2*x).^a2; 
case 'Gausian'
  f2=(1/(2*pi*a2))*exp(-((x-1).*(x-1))/(2*a2*a2));
otherwise
  f2=a2*(x.^3)+b2*(x.^2)+c2*x; 
end

f1=f1-f1(1);
f2=f2-f2(1);
f1=[f1 fliplr(f1)];
f2=[f2 fliplr(f2)];
if max(f1)~=0
      f1=f1/max(f1);
end
if max(f2)~=0
      f2=f2/max(f2);
end
b=conv(f1,f2)*dn;
f1=f1(1:2*n);
f2=f2(1:2*n);
b=b(1:4*n);
bh=tohermit(b);
[h1,w]=freqz(f1,1,400); h1=20*log10(abs(h1')/abs(h1(1))); 
[h2,w]=freqz(f2,1,400); h2=20*log10(abs(h2')/abs(h2(1))); 
[hh,w]=freqz(bh,1,400); hh=20*log10(abs(hh')/abs(hh(1))); 
[hb,w]=freqz(b,1,400); hb=20*log10(abs(hb')/abs(hb(1))); w=w'/(2*pi);

function update_gui(fn1,fn2,a1,b1,c1,a2,b2,c2)
%
%
  [f1,f2,b,bh,w,h1,h2,hb,hh]=update_signal(fn1,fn2,a1,b1,c1,a2,b2,c2);
  hndlList=get(gcf,'Userdata');
  tf=0:0.01:1.99;
  tb=0:0.01:3.99;
  hd1 = get(hndlList(1),'Children');
  hd2 = get(hndlList(2),'Children');
  hd3 = get(hndlList(3),'Children');
  hd4 = get(hndlList(4),'Children');
  set(hd1(1),'XData',tf);
  set(hd1(1),'YData',f1);
  set(hd1(2),'XData',tf);
  set(hd1(2),'YData',f2);
  set(hd2(1),'XData',w);
  set(hd2(1),'YData',h1);
  set(hd2(2),'XData',w);
  set(hd2(2),'YData',h2);
  set(hd2(3),'XData',w(1:80)*10);
  set(hd2(3),'YData',h1(1:80));
  set(hd2(4),'XData',w(1:80)*10);
  set(hd2(4),'YData',h2(1:80));
  set(hd3(1),'XData',tb);
  set(hd3(1),'YData',b);
  set(hd3(2),'XData',tb);
  set(hd3(2),'YData',bh);
  set(hd4(1),'XData',w);
  set(hd4(1),'YData',hb);
  set(hd4(2),'XData',w);
  set(hd4(2),'YData',hh);
  set(hd4(3),'XData',w(1:80)*10);
  set(hd4(3),'YData',hb(1:80));
  set(hd4(4),'XData',w(1:80)*10);
  set(hd4(4),'YData',hh(1:80));
%____________________________________________________________________
%
function save_spline(param);

switch param, 
case 'initialize',
      fL=get(gcbf,'Userdata');
      ndx= get(fL( 5),'Value');
      prm= get(fL( 5),'UserData');
      prm=prm{1}; 
      fn1=prm(ndx);
      ndx= get(fL( 6),'Value');
      prm= get(fL( 6),'UserData');
      prm=prm{1};
      fn2=prm(ndx);
      a1 = get(fL( 7),'Value');
      b1 = get(fL( 8),'Value');
      c1 = get(fL( 9),'Value');
      a2 = get(fL(10),'Value');
      b2 = get(fL(11),'Value');
      c2 = get(fL(12),'Value');
  ord=8;
  n=fix(200/ord);
  [f1,f2,b,bh]=update_signal(fn1,fn2,a1,b1,c1,a2,b2,c2,ord*n);
  lb=length(b);
  t=1:lb; t=t/(ord*n);
  tu=t(1:n:lb);

  h1 = figure('Units','points', ...
        'WindowStyle','modal',...
        'NumberTitle','off',...
	'Color',[0.8 0.8 0.8], ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[12 30.75 420 281.25], ...
	'Tag','Fig2', ...
        'Name','Save base spline', ...  
	'ToolBar','none');
popstr1={'Hermite' 'B-form' 'All form'};
pm1 = uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.823 0.88 0.157 0.06], ...
	'String',popstr1, ...
	'Style','popupmenu', ...
	'Tag','PopupMenu1', ...
	'Value',1);
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'BackgroundColor',[0.93 0.75 0.75], ...
	'ListboxTop',0, ...
	'Position',[0.823 0.94 0.155 0.053], ...
	'String','Form spline', ...
	'Style','text', ...
	'Tag','StaticText1');
popstr2={'Mat' 'ASCII' 'ASCII Double'};
pm2 = uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.823 0.76 0.157 0.06], ...
	'String',popstr2, ...
	'Style','popupmenu', ...
	'Tag','PopupMenu2', ...
	'Value',1);
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'ListboxTop',0, ...
	'Position',[0.823 0.82 0.155 0.053], ...
	'String','File format', ...
	'Style','text', ...
	'Tag','StaticText1');
    fname = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'HorizontalAlignment','left', ...
        'Position', [0.17 0.94 0.64 0.05], ...
        'BackgroundColor','w',...
        'String',[pwd '\basespl']);
    uifname=uicontrol( ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.01 0.94 0.15 0.05], ...
	'String','file name:', ... 
        'Callback','crspline(''savespl'',''file'')', ...
	'Style','pushbutton');
    comm = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'HorizontalAlignment','left', ...
        'Position', [0.17 0.88 0.64 0.05], ...
        'BackgroundColor','w',...
        'String',date );
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.01 0.88 0.15 0.05], ...
	'String','comment:', ...
	'Style','text');
    hform = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'HorizontalAlignment','left', ...
        'Position', [0.17 0.82 0.64 0.05], ...
        'BackgroundColor','w',...
        'String',num2str(bh(1:n:lb)));
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.01 0.82 0.15 0.05], ...
	'String','H-form:', ...
	'Style','text');
    bform = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'HorizontalAlignment','left', ...
        'Position', [0.17 0.76 0.64 0.05], ...
        'BackgroundColor','w',...
        'String',num2str(b(1:n:lb)));
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.01 0.76 0.15 0.05], ...
	'String','B-form:', ...
	'Style','text');

    order = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'HorizontalAlignment','left', ...
        'Position', [0.823 0.64 0.155 0.053], ...
        'BackgroundColor','w',...
        'CallBack','crspline(''savespl'',''order'');',...
        'Value',8,...
        'String','8');
      uicontrol('Parent',h1, ...
	'Units','normalized', ...
	'ListboxTop',0, ...
	'Position',[0.823 0.70 0.155 0.053], ...
	'String','order', ...
	'Style','text');

ax4 = axes('Parent',h1, ...
	'Color',[1 1 1], ...
        'FontSize',[8], ...
	'Position',[0.05 0.05 0.75 0.65], ...
	'Tag','Axes1'); plot(t,b,t,bh,tu,b(1:n:lb),'.',tu,bh(1:n:lb),'.');
        a=axis; a(1)=0; a(2)=4; axis(a);
        set(ax4,'YLimMode','auto');
%==============================================================
   % Info and Close buttons
   tposition6 = [.83 .12 .15 .05];
   uicontrol(...
      'String','Save',...
      'Units','normalized',...
      'Position',tposition6,...
      'Callback','crspline(''savespl'',''save'')');
   tposition8 = [.83 .01 .15 .05];
   uicontrol(...
      'String','Close',...
      'Units','normalized',...
      'ForegroundColor','black',...
      'Position',tposition8,...
      'Callback','crspline(''done'')');
%==============================================================
 hndlList=[pm1 pm2 fname comm hform bform order ax4 fL];
 set(h1,'UserData',hndlList);

case 'order'
   hL=get(gcf,'Userdata');
   ndx= get(hL(5+8),'Value');
   prm= get(hL(5+8),'UserData');
   prm=prm{1}; 
   fn1=prm(ndx);
   ndx= get(hL(6+8),'Value');
   prm= get(hL(6+8),'UserData');
   prm=prm{1};
   fn2=prm(ndx);
   a1 = get(hL( 7+8),'Value');
   b1 = get(hL( 8+8),'Value');
   c1 = get(hL( 9+8),'Value');
   a2 = get(hL(10+8),'Value');
   b2 = get(hL(11+8),'Value');
   c2 = get(hL(12+8),'Value');

   vid =hL(1);
   form=hL(2);
   name=hL(3);
   comm=hL(4);
   ord =get(hL(7),'Value');
   ord=fix(str2num(get(order,'String')));
   if ord<2
      ord=2;
   end
   if ord>200
      ord=200;
   end
   set(order,'String',num2str(ord));
   set(order,'Value',ord);
   n=fix(200/ord);
   [f1,f2,b,bh]=update_signal(fn1,fn2,a1,b1,c1,a2,b2,c2,ord*n);
   lb=length(b);
   t=1:lb; t=t/(ord*n);
   tu=t(1:n:lb);
   bhd=bh(1:n:lb);
   bd=b(1:n:lb);
   set(hform,'String',num2str(bhd));
   set(bform,'String',num2str(bd));
   hd1=get(ax4,'Children');
   set(hd1(4),'XData',t);
   set(hd1(4),'YData',b);
   set(hd1(3),'XData',t);
   set(hd1(3),'YData',bh);
   set(hd1(2),'XData',tu);
   set(hd1(2),'YData',bhd);
   set(hd1(1),'XData',tu);
   set(hd1(1),'YData',bd);
case 'file'
   hL=get(gcf,'Userdata');
   form =get(hL(2),'Value');
   if form==1
      [fn,fp]=uiputfile('*.mat','Save base spline');
   else
      [fn,fp]=uiputfile('*.txt','Save base spline');
   end
   newname=[fp fn];
   if ischar(newname)
       set(hL(3),'String',newname);
   end
case 'save'
   hL=get(gcf,'Userdata');
   ndx= get(hL(5+8),'Value');
   prm= get(hL(5+8),'UserData');
   prm=prm{1}; 
   fn1=prm(ndx);
   ndx= get(hL(6+8),'Value');
   prm= get(hL(6+8),'UserData');
   prm=prm{1};
   fn2=prm(ndx);
   a1 = get(hL( 7+8),'Value');
   b1 = get(hL( 8+8),'Value');
   c1 = get(hL( 9+8),'Value');
   a2 = get(hL(10+8),'Value');
   b2 = get(hL(11+8),'Value');
   c2 = get(hL(12+8),'Value');
   vid  =get(hL(1),'Value');
   form =get(hL(2),'Value');
   ord  =get(hL(7),'Value');
   name =get(hL(3),'String');
   comm =get(hL(4),'String');
   n=fix(200/ord);
   [f1,f2,b,bh]=update_signal(fn1,fn2,a1,b1,c1,a2,b2,c2,ord*n);
   lb=length(b);
   t=1:lb; t=t/(ord*n);
   tu=t(1:n:lb);
   bhd=bh(1:n:lb);
   bd=b(1:n:lb);
   if vid==1
      spl=bhd';
   end
   if vid==2
      spl=bd';
   end
   if vid==3 
      spl=[bd',bhd'];
   end
   if form==1
      eval(['save ' name ' spl comm;']);
   end
   if form==2
      eval(['save ' name ' spl -ASCII;']); 
   end
   if form==3
      eval(['save ' name ' spl -ASCII -DOUBLE;']); 
   end
   msgbox('Spline saved');
end
